# To obtain different panels of Figures 2 and 3 in the paper, search for "choose one of:"
#   and make appropriate changes.
from numpy import linalg
from numpy import dot
import numpy as np
import matplotlib.pyplot as plt
n = 1000           # the size of the training set (choose one of: 10, 1000)
x_test = 0         # the test object (choose one of: 0, 1)
np.random.seed(0)       # for reproducibility and comparability
x = np.random.random(n) # initializing the training attributes
y = x * (2*np.random.random(n)-1)  # intializing the training labels
K = np.zeros((n,n))     # initializing the kernel matrix
k = np.zeros(n)         # initializing the kernel vector
C = np.zeros(n)         # initializing the conformal C values
for i in range(n):
  for j in range(n):
    K[i,j] = x[i]*x[j]    # the kernel matrix (with a ridge)
for i in range(n):
  k[i] = x[i] * x_test    # the kernel vector
kappa = x_test * x_test   # the kernel scalar
K_inv = linalg.inv(K+np.eye(n))
epsilon = dot(K_inv,k)
hat_test = dot(y,epsilon)
Bayes_spread = 1 + kappa - dot(k,epsilon)
y_hat = dot(dot(K_inv,K),y)
C = hat_test + (y-y_hat)*Bayes_spread/(1+epsilon)
C_srt = np.sort(C)
plt.plot([-1.2,C_srt[0]],[0,0],'b')
plt.plot([-1.2,C_srt[0]],[1/(n+1),1/(n+1)],'b')
for i in range(n-1):
  plt.plot([C_srt[i],C_srt[i]],[i/(n+1),(i+2)/(n+1)],'b')
  plt.plot([C_srt[i],C_srt[i+1]],[(i+1)/(n+1),(i+1)/(n+1)],'b')
  plt.plot([C_srt[i],C_srt[i+1]],[(i+2)/(n+1),(i+2)/(n+1)],'b')
plt.plot([C_srt[n-1],C_srt[n-1]],[(n-1)/(n+1),1],'b')
plt.plot([C_srt[n-1],1.2],[n/(n+1),n/(n+1)],'b')
plt.plot([C_srt[n-1],1.2],[1,1],'b')
plt.show()
